#include <LibCore/CLocalSocket.h>
#include <sys/socket.h>
#include <errno.h>

CLocalSocket::CLocalSocket(int fd, CObject* parent)
    : CSocket(CSocket::Type::Local, parent)
{
    // NOTE: This constructor is used by CLocalServer::accept(), so the socket is already connected.
    m_connected = true;
    set_fd(fd);
    set_mode(CIODevice::ReadWrite);
    set_error(0);
}

CLocalSocket::CLocalSocket(CObject* parent)
    : CSocket(CSocket::Type::Local, parent)
{
    int fd = socket(AF_LOCAL, SOCK_STREAM | SOCK_NONBLOCK | SOCK_CLOEXEC, 0);
    if (fd < 0) {
        set_error(errno);
    } else {
        set_fd(fd);
        set_mode(CIODevice::ReadWrite);
        set_error(0);
    }
}

CLocalSocket::~CLocalSocket()
{
}
